# project imports
from esm_ensemble_init import *

from os.path import join
import sys
import os
import random
try:
    import configparser
except ImportError:
    # Python 2.x fallback
    import ConfigParser as configparser
from time import time

# COMPSs/PyCOMPSs imports
from pycompss.api.task import task
from pycompss.api.binary import binary
from pycompss.api.constraint import constraint
from pycompss.api.mpi import mpi
from pycompss.api.api import compss_wait_on
from pycompss.api.api import compss_barrier
from pycompss.api.api import TaskGroup
from pycompss.api.api import compss_barrier_group
from pycompss.api.parameter import *

# date
# mpirun -n 288 fesom.x > fesom2_log.out
# date

# check: https://able.bio/rhett/how-to-set-and-get-environment-variables-in-python--274rgt5
# TODO: working dirr and binary path should be variables
@mpi(binary="${FESOM_WORKINGDIR}/${FESOM_EXE}", runner="mpirun", processes="${FESOM_CORES}", working_dir="${FESOM_WORKINGDIR}", fail_by_exit_value=True)
@task(log_file={Type:FILE_OUT, StdIOStream:STDOUT})
def esm_simulation(log_file):
   pass


#def esm_pruning():
   # 1 - connect to hecuba and obtain values

   # 2 - for each simulation to be stopped, remove it from the task group

   # 3 - remove its data from hecuba and remove its working directory and generated outputs

# takes the ensemble config file and prepares folders and config files


   # 3 - prepare config files for each simulation: replace placeholders in namelists for each member of the ensemble (start date), create fesom.clock. etc

# function to run ESM ensemble, each one should have different start dates or initial conditions/ forcings
# for making sense
def esm_ensemble(exp_id):

   # 1 - Creation of group
   with TaskGroup(str(exp_id), False):
      #2 - launch Analysis agent for the pruning

      #3 - Launch the ensemble members
      # TODO: add the runtime path and output path of each on
      sdates_list = (exp_settings['common']['ensemble_start_dates']).split()
      for sdate in sdates_list:
         log = exp_settings['common']['top_working_dir'] + "/" + str(sdate) + "/" + "fesom2_" + str(exp_id) + "_" + str(sdate) + ".out"
         #working_dir = exp_settings['common']['top_working_dir'] + "/" + sdate
         #wdir = "/home/bsc32/bsc32044/pycompss_workflow_tests/1948"
         esm_simulation(log)

   compss_barrier_group(str(exp_id))



if __name__ == "__main__":
   print("Running FESOM2 -Pycompss")
   # 0 - create a ramdon nr for the experiment id
   exp_id = random.randint(100000, 999999)
   # prepare folder structure/configuration
   exp_settings = compss_wait_on(esm_ensemble_init(exp_id))
  # exp_settings =  compss_wait_on(exp_settings)
   print("##################################### Initialization completed ####################################")
   # run the experiment
   esm_ensemble(exp_id)


